/* ************************************************************************** */
/*                                                                            */
/*                                                        :::      ::::::::   */
/*   minishell.h                                        :+:      :+:    :+:   */
/*                                                    +:+ +:+         +:+     */
/*   By: cchauvet <cchauvet@student.42angoulem      +#+  +:+       +#+        */
/*                                                +#+#+#+#+#+   +#+           */
/*   Created: 2023/02/14 13:45:30 by cchauvet          #+#    #+#             */
/*   Updated: 2023/02/16 16:12:26 by cchauvet         ###   ########.fr       */
/*                                                                            */
/* ************************************************************************** */

#ifndef MINISHELL_H
# define MINISHELL_H
# include "libftx/libftx.h"
# include "utils/utils.h"
# include <sys/types.h>
# include <sys/stat.h>
# include <fcntl.h>
# include <sys/wait.h>
# include <stdio.h>
# include <readline/readline.h>
# include <readline/history.h>

t_list		**init_env(char **env);
int			set_value_key(t_list **env, char *key, char *value);
char		*get_value_index(int index, t_list **head);
char		*get_value_key(char *key, t_list **head);
int			ft_syntatic_verif(const char *str);
int			ft_file_is_readable(const char *path);
int			ft_file_is_writable(const char *path);
int			ft_file_is_appendable(const char *path);
char		*ft_get_file_path(const char *infile);
int			ft_infile(char *line);
int			ft_outfile(char *line);
int			ft_heredoc(char *stop);
size_t		ft_seglen_quoted(const char *str, char c);
int			ft_cmds_executor(t_list **cmds, char **env);
char		**ft_split_quoted(const char *s, char c);
void		ft_cmddel(void *content);
void		env_del(void *content);
t_list		**ft_parse_cmds(char *line);
int			ft_cmd_filler(t_list *current, char **args);
char		*ft_normalizer(char *str);

typedef struct s_cmd
{
	int		fd_in;
	int		fd_out;
	char	*executable;
	char	**args;
}	t_cmd;

typedef struct s_data
{
	t_list	**env;
	int		heredoc;
}	t_data;

typedef struct s_env
{
	void	*key;
	void	*value;
}	t_env;

#endif
